import React from 'react';
import PropTypes from 'prop-types';
import styled from 'styled-components';
import { ifProp, prop } from 'styled-tools';
import { a as as, b as classCallCheck, c as inherits, d as objectWithoutProperties, e as possibleConstructorReturn, f as _extends } from './as-8a1cd76d.js';
import Base from './Base.js';
import 'lodash-es/uniq';
import 'react-known-props';
import 'lodash-es/omit';
import './chunk-a29c7f2d.js';
import 'lodash-es/kebabCase';
import './chunk-84d8695a.js';

var Component = function Component(props) {
  if (props.block) {
    return React.createElement(
      Base,
      _extends({ as: "pre" }, props),
      React.createElement(
        "code",
        { className: props.codeClassName },
        props.children
      )
    );
  }
  var className = props.codeClassName ? (props.className + " " + props.codeClassName).trim() : ("" + props.className).trim();
  return React.createElement(Base, _extends({ as: "code" }, props, { className: className }));
};

var Code = styled(Base).withConfig({
  displayName: "Code"
})(["background-color:rgba(0,0,0,0.05);font-family:monospace;white-space:pre-wrap;word-wrap:break-word;padding:", ";code{display:block;padding:1em;}", ";"], ifProp("block", "0", "0.25em 0.35em"), prop("theme.Code"));

Code.propTypes = {
  block: PropTypes.bool,
  codeClassName: PropTypes.string
};

var Code$1 = as(Component)(Code);

export default Code$1;
