import PropTypes from 'prop-types';
import styled from 'styled-components';
import { prop } from 'styled-tools';
import { a as as } from './as-8a1cd76d.js';
import { a as bool, b as value } from './chunk-a29c7f2d.js';
import Base from './Base.js';
import 'lodash-es/uniq';
import 'react-known-props';
import 'react';
import 'lodash-es/omit';
import 'lodash-es/kebabCase';
import './chunk-84d8695a.js';

var Grid = styled(Base).withConfig({
  displayName: "Grid"
})(["display:grid;&&&{", " ", " ", " ", " ", " ", " ", " ", "}", ";"], bool("grid-auto-flow", ["row", "column", "dense"]), value("grid-gap", "gap"), value("grid-template", "template"), value("grid-template-areas", "areas"), value("grid-template-columns", "columns"), value("grid-template-rows", "rows"), value("grid-auto-columns", "autoColumns"), value("grid-auto-rows", "autoRows"), prop("theme.Grid"));

var valueType = PropTypes.oneOfType([PropTypes.string, PropTypes.number]);

Grid.propTypes = {
  row: PropTypes.bool,
  column: PropTypes.bool,
  dense: PropTypes.bool,
  gap: valueType,
  template: valueType,
  areas: valueType,
  columns: valueType,
  rows: valueType,
  autoColumns: valueType,
  autoRows: valueType
};

var Grid$1 = as("div")(Grid);

var GridItem = styled(Base).withConfig({
  displayName: "GridItem"
})(["&&&{", ";", ";", ";", ";", ";", ";", ";}", ";"], value("grid-area", "area"), value("grid-column", "column"), value("grid-row", "row"), value("grid-column-start", "columnStart"), value("grid-column-end", "columnEnd"), value("grid-row-start", "rowStart"), value("grid-row-end", "rowEnd"), prop("theme.GridItem"));

var valueType$1 = PropTypes.oneOfType([PropTypes.string, PropTypes.number]);

GridItem.propTypes = {
  area: valueType$1,
  column: valueType$1,
  row: valueType$1,
  columnStart: valueType$1,
  columnEnd: valueType$1,
  rowStart: valueType$1,
  rowEnd: valueType$1
};

var GridItem$1 = as("div")(GridItem);

Grid$1.Item = GridItem$1;

export default Grid$1;
