import React from 'react';
import PropTypes from 'prop-types';
import styled from 'styled-components';
import { prop, ifProp } from 'styled-tools';
import { a as as, b as classCallCheck, c as inherits, d as objectWithoutProperties, e as possibleConstructorReturn, f as _extends } from './as-8a1cd76d.js';
import Overlay from './Overlay.js';
import { a as OverlayContainer, b as OverlayToggle, c as OverlayShow, d as OverlayHide } from './chunk-be7b3a82.js';
import 'lodash-es/uniq';
import 'react-known-props';
import 'lodash-es/omit';
import 'react-dom';
import './Hidden.js';
import './chunk-84d8695a.js';
import 'hoist-non-react-statics';
import './chunk-fa81e9f1.js';
import './Base.js';
import './chunk-a29c7f2d.js';
import 'lodash-es/kebabCase';
import './chunk-3cd03ec9.js';
import 'constate';
import './chunk-60576777.js';

var Component = function Component(props) {
  return React.createElement(Overlay, _extends({
    defaultSlide: props.align === "right" ? "left" : "right"
  }, props));
};

var Sidebar = styled(Component).withConfig({
  displayName: "Sidebar"
})(["top:0;height:100vh;transform:none;overflow:auto;left:", ";right:", ";", ";"], ifProp({ align: "right" }, "auto", 0), ifProp({ align: "right" }, 0, "auto"), prop("theme.Sidebar"));

Sidebar.propTypes = {
  align: PropTypes.oneOf(["left", "right"])
};

Sidebar.defaultProps = {
  align: "left",
  translateX: 0,
  translateY: 0
};

var Sidebar$1 = as("div")(Sidebar);

var SidebarContainer = OverlayContainer;

var SidebarToggle = styled(OverlayToggle).withConfig({
  displayName: "SidebarToggle"
})(["", ";"], prop("theme.SidebarToggle"));

var SidebarToggle$1 = as("button")(SidebarToggle);

var SidebarShow = styled(OverlayShow).withConfig({
  displayName: "SidebarShow"
})(["", ";"], prop("theme.SidebarShow"));

var SidebarShow$1 = as("button")(SidebarShow);

var SidebarHide = styled(OverlayHide).withConfig({
  displayName: "SidebarHide"
})(["", ";"], prop("theme.SidebarHide"));

var SidebarHide$1 = as("button")(SidebarHide);

Sidebar$1.Container = SidebarContainer;
Sidebar$1.Toggle = SidebarToggle$1;
Sidebar$1.Show = SidebarShow$1;
Sidebar$1.Hide = SidebarHide$1;

export default Sidebar$1;
