import React from 'react';
import PropTypes from 'prop-types';
import styled from 'styled-components';
import { prop } from 'styled-tools';
import { a as as, b as classCallCheck, c as inherits, d as objectWithoutProperties, e as possibleConstructorReturn, f as _extends } from './as-8a1cd76d.js';
import Hidden from './Hidden.js';
import { c as HiddenToggle, b as HiddenShow, a as HiddenHide } from './chunk-60576777.js';
import { a as StepContainer, b as StepNext, c as StepPrevious } from './chunk-6fa58b5b.js';
import 'lodash-es/uniq';
import 'react-known-props';
import 'lodash-es/omit';
import './chunk-84d8695a.js';
import 'hoist-non-react-statics';
import './chunk-fa81e9f1.js';
import './Base.js';
import './chunk-a29c7f2d.js';
import 'lodash-es/kebabCase';
import './chunk-3cd03ec9.js';
import 'constate';

var noop = function noop() {
  return false;
};

var Component = function (_React$Component) {
  inherits(Component, _React$Component);

  function Component(props) {
    classCallCheck(this, Component);

    var _this = possibleConstructorReturn(this, _React$Component.call(this, props));

    var _this$props = _this.props,
        register = _this$props.register,
        step = _this$props.step,
        order = _this$props.order;

    register(step, order);
    return _this;
  }

  Component.prototype.componentDidUpdate = function componentDidUpdate(prevProps) {
    var _props = this.props,
        step = _props.step,
        update = _props.update,
        order = _props.order;

    if (prevProps.step !== step || prevProps.order !== order) {
      update(prevProps.step, step, order);
    }
  };

  Component.prototype.componentWillUnmount = function componentWillUnmount() {
    var _props2 = this.props,
        step = _props2.step,
        unregister = _props2.unregister;

    unregister(step);
  };

  Component.prototype.render = function render() {
    var _props3 = this.props,
        isCurrent = _props3.isCurrent,
        step = _props3.step;

    return React.createElement(Hidden, _extends({ unmount: true, visible: isCurrent(step) }, this.props));
  };

  return Component;
}(React.Component);

var Step = styled(Component).withConfig({
  displayName: "Step"
})(["", ";"], prop("theme.Step"));

Step.propTypes = {
  step: PropTypes.string.isRequired,
  register: PropTypes.func.isRequired,
  update: PropTypes.func.isRequired,
  unregister: PropTypes.func.isRequired,
  isCurrent: PropTypes.func.isRequired,
  order: PropTypes.number
};

Step.defaultProps = {
  register: noop,
  update: noop,
  unregister: noop,
  isCurrent: noop
};

var Step$1 = as("div")(Step);

var toggle = function toggle(props) {
  return function () {
    return props.toggle && props.toggle(props.step);
  };
};
var Component$1 = function Component(props) {
  return React.createElement(HiddenToggle, _extends({}, props, { toggle: toggle(props) }));
};

var StepToggle = styled(Component$1).withConfig({
  displayName: "StepToggle"
})(["", ";"], prop("theme.StepToggle"));

StepToggle.propTypes = {
  toggle: PropTypes.func.isRequired,
  step: PropTypes.string.isRequired
};

var StepToggle$1 = as("button")(StepToggle);

var show = function show(props) {
  return function () {
    return props.show && props.show(props.step);
  };
};
var Component$2 = function Component(props) {
  return React.createElement(HiddenShow, _extends({}, props, { show: show(props) }));
};

var StepShow = styled(Component$2).withConfig({
  displayName: "StepShow"
})(["", ";"], prop("theme.StepShow"));

StepShow.propTypes = {
  show: PropTypes.func.isRequired,
  step: PropTypes.string.isRequired
};

var StepShow$1 = as("button")(StepShow);

var StepHide = styled(HiddenHide).withConfig({
  displayName: "StepHide"
})(["", ";"], prop("theme.StepHide"));

var StepHide$1 = as("button")(StepHide);

Step$1.Container = StepContainer;
Step$1.Toggle = StepToggle$1;
Step$1.Show = StepShow$1;
Step$1.Hide = StepHide$1;
Step$1.Next = StepNext;
Step$1.Previous = StepPrevious;

export default Step$1;
