import React from 'react';
import PropTypes from 'prop-types';
import { Container } from 'constate';
import { b as classCallCheck, c as inherits, d as objectWithoutProperties, e as possibleConstructorReturn, f as _extends } from './as-8a1cd76d.js';

var initialState = { visible: false };

var toggle = function toggle() {
  return function (state) {
    return { visible: !state.visible };
  };
};

var show = function show() {
  return function () {
    return { visible: true };
  };
};

var hide = function hide() {
  return function () {
    return { visible: false };
  };
};

var HiddenContainer = function HiddenContainer(props) {
  return React.createElement(Container, _extends({}, props, {
    initialState: _extends({}, initialState, props.initialState),
    actions: _extends({ toggle: toggle, show: show, hide: hide }, props.actions)
  }));
};

HiddenContainer.propTypes = {
  initialState: PropTypes.object,
  actions: PropTypes.objectOf(PropTypes.func)
};

export { HiddenContainer as a };
