import kebabCase from 'lodash-es/kebabCase';
import { a as numberToPx } from './chunk-84d8695a.js';

var bool = function bool(cssProp, validComponentProps) {
  return function (props) {
    var keys = Object.keys(props).filter(function (k) {
      return validComponentProps.indexOf(k) >= 0;
    }).filter(function (k) {
      return !!props[k];
    }).map(kebabCase);
    if (keys.length) {
      return cssProp + ": " + keys.join(" ") + ";";
    }
    return "";
  };
};

var value = function value(cssProp, componentProp) {
  return function (props) {
    var v = props[componentProp];
    if (typeof v === "undefined") return "";
    return cssProp + ": " + numberToPx(v) + ";";
  };
};

export { bool as a, value as b };
