'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = _interopDefault(require('react'));
var PropTypes = _interopDefault(require('prop-types'));
var styled = require('styled-components');
var styled__default = _interopDefault(styled);
var styledTools = require('styled-tools');
var as = require('./as-abd2c25b.js');
var Base = require('./Base.js');
require('lodash/uniq');
require('react-known-props');
require('lodash/omit');
require('./chunk-7e606c56.js');
require('lodash/kebabCase');
require('./chunk-c628ddbd.js');

var Component = function Component(props) {
  if (props.block) {
    return React.createElement(
      Base.default,
      as._extends({ as: "pre" }, props),
      React.createElement(
        "code",
        { className: props.codeClassName },
        props.children
      )
    );
  }
  var className = props.codeClassName ? (props.className + " " + props.codeClassName).trim() : ("" + props.className).trim();
  return React.createElement(Base.default, as._extends({ as: "code" }, props, { className: className }));
};

var Code = styled__default(Base.default).withConfig({
  displayName: "Code"
})(["background-color:rgba(0,0,0,0.05);font-family:monospace;white-space:pre-wrap;word-wrap:break-word;padding:", ";code{display:block;padding:1em;}", ";"], styledTools.ifProp("block", "0", "0.25em 0.35em"), styledTools.prop("theme.Code"));

Code.propTypes = {
  block: PropTypes.bool,
  codeClassName: PropTypes.string
};

var Code$1 = as.as(Component)(Code);

exports.default = Code$1;
