'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var PropTypes = _interopDefault(require('prop-types'));
var styled = require('styled-components');
var styled__default = _interopDefault(styled);
var styledTools = require('styled-tools');
var as = require('./as-abd2c25b.js');
var __chunk_2 = require('./chunk-7e606c56.js');
var Base = require('./Base.js');
require('lodash/uniq');
require('react-known-props');
require('react');
require('lodash/omit');
require('lodash/kebabCase');
require('./chunk-c628ddbd.js');

var Grid = styled__default(Base.default).withConfig({
  displayName: "Grid"
})(["display:grid;&&&{", " ", " ", " ", " ", " ", " ", " ", "}", ";"], __chunk_2.bool("grid-auto-flow", ["row", "column", "dense"]), __chunk_2.value("grid-gap", "gap"), __chunk_2.value("grid-template", "template"), __chunk_2.value("grid-template-areas", "areas"), __chunk_2.value("grid-template-columns", "columns"), __chunk_2.value("grid-template-rows", "rows"), __chunk_2.value("grid-auto-columns", "autoColumns"), __chunk_2.value("grid-auto-rows", "autoRows"), styledTools.prop("theme.Grid"));

var valueType = PropTypes.oneOfType([PropTypes.string, PropTypes.number]);

Grid.propTypes = {
  row: PropTypes.bool,
  column: PropTypes.bool,
  dense: PropTypes.bool,
  gap: valueType,
  template: valueType,
  areas: valueType,
  columns: valueType,
  rows: valueType,
  autoColumns: valueType,
  autoRows: valueType
};

var Grid$1 = as.as("div")(Grid);

var GridItem = styled__default(Base.default).withConfig({
  displayName: "GridItem"
})(["&&&{", ";", ";", ";", ";", ";", ";", ";}", ";"], __chunk_2.value("grid-area", "area"), __chunk_2.value("grid-column", "column"), __chunk_2.value("grid-row", "row"), __chunk_2.value("grid-column-start", "columnStart"), __chunk_2.value("grid-column-end", "columnEnd"), __chunk_2.value("grid-row-start", "rowStart"), __chunk_2.value("grid-row-end", "rowEnd"), styledTools.prop("theme.GridItem"));

var valueType$1 = PropTypes.oneOfType([PropTypes.string, PropTypes.number]);

GridItem.propTypes = {
  area: valueType$1,
  column: valueType$1,
  row: valueType$1,
  columnStart: valueType$1,
  columnEnd: valueType$1,
  rowStart: valueType$1,
  rowEnd: valueType$1
};

var GridItem$1 = as.as("div")(GridItem);

Grid$1.Item = GridItem$1;

exports.default = Grid$1;
