'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var styled = require('styled-components');
var styled__default = _interopDefault(styled);
var styledTools = require('styled-tools');
var as = require('./as-abd2c25b.js');
var Box = require('./Box.js');
var PropTypes = _interopDefault(require('prop-types'));
var Base = require('./Base.js');
require('lodash/uniq');
require('react-known-props');
require('react');
require('lodash/omit');
require('./chunk-7e606c56.js');
require('lodash/kebabCase');
require('./chunk-c628ddbd.js');

var GroupItem = styled__default(Box.default).withConfig({
  displayName: "GroupItem"
})(["", ";"], styledTools.prop("theme.GroupItem"));

var GroupItem$1 = as.as("div")(GroupItem);

var verticalAt = function verticalAt(pass, fail) {
  return styledTools.ifProp("verticalAt", styled.css(["@media (min-width:", "px){", ";}@media (max-width:", "px){", ";}"], styledTools.withProp("verticalAt", function (x) {
    return x + 1;
  }), fail, styledTools.prop("verticalAt"), pass), fail);
};

var Group = styled__default(Base.default).withConfig({
  displayName: "Group"
})(["display:flex;flex-direction:", ";", ";> *,> * ", "{min-height:2.5em;height:auto;}> *:not(:first-child):not(:last-child),> *:not(:first-child):not(:last-child) ", "{border-radius:0;", ";}> *:first-child,> *:first-child ", "{border-bottom-right-radius:0;", ";}> *:last-child,> *:last-child ", "{border-top-left-radius:0;", ";}", ";"], styledTools.ifProp("vertical", "column", "row"), verticalAt("flex-direction: column"), GroupItem$1, GroupItem$1, verticalAt(styled.css(["border-top-width:0;"]), styled.css(["border-", "-width:0;"], styledTools.ifProp("vertical", "top", "left"))), GroupItem$1, verticalAt(styled.css(["border-bottom-left-radius:0;"]), styled.css(["border-", "-radius:0;"], styledTools.ifProp("vertical", "bottom-left", "top-right"))), GroupItem$1, verticalAt(styled.css(["border-top-width:0;border-top-right-radius:0;"]), styled.css(["border-", "-width:0;border-", "-radius:0;"], styledTools.ifProp("vertical", "top", "left"), styledTools.ifProp("vertical", "top-right", "bottom-left"))), styledTools.prop("theme.Group"));

Group.propTypes = {
  vertical: PropTypes.bool,
  verticalAt: PropTypes.number
};

Group.defaultProps = {
  role: "group"
};

var Group$1 = as.as("div")(Group);

Group$1.Item = GroupItem$1;

exports.default = Group$1;
