'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = _interopDefault(require('react'));
var ReactDOM = require('react-dom');
var ReactDOM__default = _interopDefault(ReactDOM);
var styled = require('styled-components');
var styled__default = _interopDefault(styled);
var styledTools = require('styled-tools');
var as = require('./as-abd2c25b.js');
var Hidden = require('./Hidden.js');
var __chunk_6 = require('./chunk-ea25999e.js');
require('lodash/uniq');
require('react-known-props');
require('lodash/omit');
require('./chunk-c628ddbd.js');
require('prop-types');
require('hoist-non-react-statics');
require('./chunk-c7f60f29.js');
require('./Base.js');
require('./chunk-7e606c56.js');
require('lodash/kebabCase');
require('./chunk-df525803.js');
require('constate');
require('./chunk-e0ed6a07.js');

var Component = function (_React$Component) {
  as.inherits(Component, _React$Component);

  function Component() {
    var _temp, _this, _ret;

    as.classCallCheck(this, Component);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = as.possibleConstructorReturn(this, _React$Component.call.apply(_React$Component, [this].concat(args))), _this), _this.state = {}, _temp), as.possibleConstructorReturn(_this, _ret);
  }

  Component.prototype.componentDidMount = function componentDidMount() {
    var wrapper = document.createElement("div");
    document.body.appendChild(wrapper);
    this.setState({ wrapper: wrapper });
  };

  Component.prototype.componentWillUnmount = function componentWillUnmount() {
    document.body.removeChild(this.state.wrapper);
  };

  Component.prototype.render = function render() {
    var wrapper = this.state.wrapper;

    if (wrapper) {
      return ReactDOM__default.createPortal(React.createElement(Hidden.default, this.props), wrapper);
    }
    return null;
  };

  return Component;
}(React.Component);

var Overlay = styled__default(Component).withConfig({
  displayName: "Overlay"
})(["position:fixed;background-color:white;left:50%;top:50%;z-index:19900410;", ";"], styledTools.prop("theme.Overlay"));

Overlay.defaultProps = {
  role: "dialog",
  "aria-modal": true,
  hideOnEsc: true,
  translateX: "-50%",
  translateY: "-50%",
  defaultSlide: "top"
};

var Overlay$1 = as.as("div")(Overlay);

Overlay$1.Container = __chunk_6.OverlayContainer;
Overlay$1.Toggle = __chunk_6.OverlayToggle;
Overlay$1.Show = __chunk_6.OverlayShow;
Overlay$1.Hide = __chunk_6.OverlayHide;

exports.default = Overlay$1;
