'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = _interopDefault(require('react'));
var ReactDOM = require('react-dom');
var ReactDOM__default = _interopDefault(ReactDOM);
var PropTypes = _interopDefault(require('prop-types'));
var styled = require('styled-components');
var styled__default = _interopDefault(styled);
var styledTools = require('styled-tools');
var Popper = _interopDefault(require('popper.js'));
var as = require('./as-abd2c25b.js');
var Hidden = require('./Hidden.js');
var Box = require('./Box.js');
var __chunk_7 = require('./chunk-a74c92bb.js');
var uniqueId = _interopDefault(require('lodash/uniqueId'));
var __chunk_4 = require('./chunk-df525803.js');
var __chunk_3 = require('./chunk-c7f60f29.js');
var __chunk_5 = require('./chunk-e0ed6a07.js');
require('lodash/uniq');
require('react-known-props');
require('lodash/omit');
require('./chunk-c628ddbd.js');
require('hoist-non-react-statics');
require('./Base.js');
require('./chunk-7e606c56.js');
require('lodash/kebabCase');
require('constate');
require('./Arrow.js');

/* eslint-disable react/no-find-dom-node */

var HiddenBox = Hidden.default.as(Box.default);

var Component = function (_React$Component) {
  as.inherits(Component, _React$Component);

  function Component() {
    var _temp, _this, _ret;

    as.classCallCheck(this, Component);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = as.possibleConstructorReturn(this, _React$Component.call.apply(_React$Component, [this].concat(args))), _this), _this.state = {
      placement: _this.props.placement,
      translateX: undefined,
      translateY: undefined,
      originX: undefined,
      originY: undefined
    }, _this.getPopover = function () {
      return ReactDOM.findDOMNode(_this);
    }, _this.modifier = function (data) {
      var placement = data.placement,
          offsets = data.offsets,
          arrowElement = data.arrowElement,
          arrowStyles = data.arrowStyles;
      var reference = offsets.reference,
          popper = offsets.popper;

      var _placement$split = placement.split("-"),
          position = _placement$split[0];

      var isVertical = ["top", "bottom"].indexOf(position) >= 0;

      var referenceCenter = isVertical ? reference.width / 2 : reference.height / 2;
      var side = isVertical ? "left" : "top";
      var sideValue = referenceCenter - popper[side];

      if (arrowElement) {
        var top = arrowStyles.top,
            left = arrowStyles.left;

        arrowElement.style.top = isVertical ? "" : top + "px";
        arrowElement.style.left = isVertical ? left + "px" : "";
      }

      _this.setState({
        originX: isVertical ? sideValue + "px - 50%" : 0,
        originY: !isVertical ? sideValue + "px - 50%" : 0,
        translateX: popper.left,
        translateY: popper.top,
        placement: data.placement
      });

      return data;
    }, _this.getOptions = function () {
      var placement = _this.props.placement;

      var popover = _this.getPopover();
      var arrowClassName = "." + __chunk_7.PopoverArrow.styledComponentId;
      var arrow = popover.querySelector(arrowClassName);
      return {
        placement: placement,
        modifiers: {
          applyStyle: { enabled: false },
          arrow: { enabled: !!arrow, element: arrow },
          flip: { padding: 16 },
          offset: { offset: "0, " + _this.props.gutter },
          setState: {
            enabled: true,
            order: 900,
            fn: _this.modifier
          }
        }
      };
    }, _this.initPopper = function () {
      if (!_this.popper) {
        var popover = _this.getPopover();
        _this.popper = new Popper(popover.parentNode, popover, _this.getOptions());
      }
    }, _this.destroyPopper = function () {
      if (_this.popper) {
        _this.popper.destroy();
        _this.popper = undefined;
      }
    }, _temp), as.possibleConstructorReturn(_this, _ret);
  }

  Component.prototype.componentDidMount = function componentDidMount() {
    this.initPopper();
  };

  Component.prototype.componentWillUnmount = function componentWillUnmount() {
    this.destroyPopper();
  };

  Component.prototype.componentDidUpdate = function componentDidUpdate(prevProps) {
    if (prevProps.visible !== this.props.visible || prevProps.placement !== this.props.placement || prevProps.children !== this.props.children) {
      this.destroyPopper();
      this.initPopper();
    }
  };

  Component.prototype.render = function render() {
    return React.createElement(HiddenBox, as._extends({
      id: this.props.popoverId
    }, this.state, {
      "data-placement": this.state.placement,
      defaultSlide: this.state.placement.replace(/-.+$/, ""),
      defaultExpand: this.state.placement.replace(/-.+$/, ""),
      slideOffset: this.props.gutter
    }, this.props));
  };

  return Component;
}(React.Component);

var Popover = styled__default(Component).withConfig({
  displayName: "Popover"
})(["position:absolute;top:0;left:0;user-select:auto;cursor:auto;color:inherit;background-color:white;padding:1em;z-index:999;outline:0;will-change:transform;&[aria-hidden=\"false\"]{transition-timing-function:", ";}", ";"], styledTools.prop("timing", "cubic-bezier(0.25, 0.1, 0.25, 1.5)"), styledTools.prop("theme.Popover"));

Popover.propTypes = {
  placement: PropTypes.oneOf(["auto", "top", "right", "bottom", "left", "top-start", "right-start", "bottom-start", "left-start", "top-end", "right-end", "bottom-end", "left-end"]),
  gutter: PropTypes.oneOfType([PropTypes.number, PropTypes.string]),
  popoverId: PropTypes.string
};

Popover.defaultProps = {
  role: "group",
  placement: "bottom",
  hideOnEsc: true,
  gutter: 12
};

var Popover$1 = as.as("div")(Popover);

var onMount = function onMount(_ref) {
  var setState = _ref.setState;

  setState({ popoverId: uniqueId("popover") });
};

var PopoverContainer = function PopoverContainer(props) {
  return React.createElement(__chunk_4.HiddenContainer, as._extends({}, props, { onMount: __chunk_3.callAll(onMount, props.onMount) }));
};

var Component$1 = function Component(props) {
  return React.createElement(__chunk_5.HiddenToggle, as._extends({
    "aria-expanded": props.visible,
    "aria-controls": props.popoverId,
    "aria-haspopup": true
  }, props));
};

var PopoverToggle = styled__default(Component$1).withConfig({
  displayName: "PopoverToggle"
})(["", ";"], styledTools.prop("theme.PopoverToggle"));

PopoverToggle.propTypes = {
  popoverId: PropTypes.string,
  visible: PropTypes.bool
};

var PopoverToggle$1 = as.as("button")(PopoverToggle);

var Component$2 = function Component(props) {
  return React.createElement(__chunk_5.HiddenShow, as._extends({
    "aria-expanded": props.visible,
    "aria-controls": props.popoverId,
    "aria-haspopup": true
  }, props));
};

var PopoverShow = styled__default(Component$2).withConfig({
  displayName: "PopoverShow"
})(["", ";"], styledTools.prop("theme.PopoverShow"));

PopoverShow.propTypes = {
  popoverId: PropTypes.string,
  visible: PropTypes.bool
};

var PopoverShow$1 = as.as("button")(PopoverShow);

var Component$3 = function Component(props) {
  return React.createElement(__chunk_5.HiddenHide, as._extends({
    "aria-expanded": props.visible,
    "aria-controls": props.popoverId,
    "aria-haspopup": true
  }, props));
};

var PopoverHide = styled__default(Component$3).withConfig({
  displayName: "PopoverHide"
})(["", ";"], styledTools.prop("theme.PopoverHide"));

PopoverHide.propTypes = {
  popoverId: PropTypes.string,
  visible: PropTypes.bool
};

var PopoverHide$1 = as.as("button")(PopoverHide);

Popover$1.Arrow = __chunk_7.PopoverArrow;
Popover$1.Container = PopoverContainer;
Popover$1.Toggle = PopoverToggle$1;
Popover$1.Show = PopoverShow$1;
Popover$1.Hide = PopoverHide$1;

exports.default = Popover$1;
