'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = _interopDefault(require('react'));
var PropTypes = _interopDefault(require('prop-types'));
var styled = require('styled-components');
var styled__default = _interopDefault(styled);
var styledTools = require('styled-tools');
var as = require('./as-abd2c25b.js');
var Overlay = require('./Overlay.js');
var __chunk_6 = require('./chunk-ea25999e.js');
require('lodash/uniq');
require('react-known-props');
require('lodash/omit');
require('react-dom');
require('./Hidden.js');
require('./chunk-c628ddbd.js');
require('hoist-non-react-statics');
require('./chunk-c7f60f29.js');
require('./Base.js');
require('./chunk-7e606c56.js');
require('lodash/kebabCase');
require('./chunk-df525803.js');
require('constate');
require('./chunk-e0ed6a07.js');

var Component = function Component(props) {
  return React.createElement(Overlay.default, as._extends({
    defaultSlide: props.align === "right" ? "left" : "right"
  }, props));
};

var Sidebar = styled__default(Component).withConfig({
  displayName: "Sidebar"
})(["top:0;height:100vh;transform:none;overflow:auto;left:", ";right:", ";", ";"], styledTools.ifProp({ align: "right" }, "auto", 0), styledTools.ifProp({ align: "right" }, 0, "auto"), styledTools.prop("theme.Sidebar"));

Sidebar.propTypes = {
  align: PropTypes.oneOf(["left", "right"])
};

Sidebar.defaultProps = {
  align: "left",
  translateX: 0,
  translateY: 0
};

var Sidebar$1 = as.as("div")(Sidebar);

var SidebarContainer = __chunk_6.OverlayContainer;

var SidebarToggle = styled__default(__chunk_6.OverlayToggle).withConfig({
  displayName: "SidebarToggle"
})(["", ";"], styledTools.prop("theme.SidebarToggle"));

var SidebarToggle$1 = as.as("button")(SidebarToggle);

var SidebarShow = styled__default(__chunk_6.OverlayShow).withConfig({
  displayName: "SidebarShow"
})(["", ";"], styledTools.prop("theme.SidebarShow"));

var SidebarShow$1 = as.as("button")(SidebarShow);

var SidebarHide = styled__default(__chunk_6.OverlayHide).withConfig({
  displayName: "SidebarHide"
})(["", ";"], styledTools.prop("theme.SidebarHide"));

var SidebarHide$1 = as.as("button")(SidebarHide);

Sidebar$1.Container = SidebarContainer;
Sidebar$1.Toggle = SidebarToggle$1;
Sidebar$1.Show = SidebarShow$1;
Sidebar$1.Hide = SidebarHide$1;

exports.default = Sidebar$1;
