'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = _interopDefault(require('react'));
var PropTypes = _interopDefault(require('prop-types'));
var styled = require('styled-components');
var styled__default = _interopDefault(styled);
var styledTools = require('styled-tools');
var as = require('./as-abd2c25b.js');
var Hidden = require('./Hidden.js');
var __chunk_5 = require('./chunk-e0ed6a07.js');
var __chunk_8 = require('./chunk-30c3ebc0.js');
require('lodash/uniq');
require('react-known-props');
require('lodash/omit');
require('./chunk-c628ddbd.js');
require('hoist-non-react-statics');
require('./chunk-c7f60f29.js');
require('./Base.js');
require('./chunk-7e606c56.js');
require('lodash/kebabCase');
require('./chunk-df525803.js');
require('constate');

var noop = function noop() {
  return false;
};

var Component = function (_React$Component) {
  as.inherits(Component, _React$Component);

  function Component(props) {
    as.classCallCheck(this, Component);

    var _this = as.possibleConstructorReturn(this, _React$Component.call(this, props));

    var _this$props = _this.props,
        register = _this$props.register,
        step = _this$props.step,
        order = _this$props.order;

    register(step, order);
    return _this;
  }

  Component.prototype.componentDidUpdate = function componentDidUpdate(prevProps) {
    var _props = this.props,
        step = _props.step,
        update = _props.update,
        order = _props.order;

    if (prevProps.step !== step || prevProps.order !== order) {
      update(prevProps.step, step, order);
    }
  };

  Component.prototype.componentWillUnmount = function componentWillUnmount() {
    var _props2 = this.props,
        step = _props2.step,
        unregister = _props2.unregister;

    unregister(step);
  };

  Component.prototype.render = function render() {
    var _props3 = this.props,
        isCurrent = _props3.isCurrent,
        step = _props3.step;

    return React.createElement(Hidden.default, as._extends({ unmount: true, visible: isCurrent(step) }, this.props));
  };

  return Component;
}(React.Component);

var Step = styled__default(Component).withConfig({
  displayName: "Step"
})(["", ";"], styledTools.prop("theme.Step"));

Step.propTypes = {
  step: PropTypes.string.isRequired,
  register: PropTypes.func.isRequired,
  update: PropTypes.func.isRequired,
  unregister: PropTypes.func.isRequired,
  isCurrent: PropTypes.func.isRequired,
  order: PropTypes.number
};

Step.defaultProps = {
  register: noop,
  update: noop,
  unregister: noop,
  isCurrent: noop
};

var Step$1 = as.as("div")(Step);

var toggle = function toggle(props) {
  return function () {
    return props.toggle && props.toggle(props.step);
  };
};
var Component$1 = function Component(props) {
  return React.createElement(__chunk_5.HiddenToggle, as._extends({}, props, { toggle: toggle(props) }));
};

var StepToggle = styled__default(Component$1).withConfig({
  displayName: "StepToggle"
})(["", ";"], styledTools.prop("theme.StepToggle"));

StepToggle.propTypes = {
  toggle: PropTypes.func.isRequired,
  step: PropTypes.string.isRequired
};

var StepToggle$1 = as.as("button")(StepToggle);

var show = function show(props) {
  return function () {
    return props.show && props.show(props.step);
  };
};
var Component$2 = function Component(props) {
  return React.createElement(__chunk_5.HiddenShow, as._extends({}, props, { show: show(props) }));
};

var StepShow = styled__default(Component$2).withConfig({
  displayName: "StepShow"
})(["", ";"], styledTools.prop("theme.StepShow"));

StepShow.propTypes = {
  show: PropTypes.func.isRequired,
  step: PropTypes.string.isRequired
};

var StepShow$1 = as.as("button")(StepShow);

var StepHide = styled__default(__chunk_5.HiddenHide).withConfig({
  displayName: "StepHide"
})(["", ";"], styledTools.prop("theme.StepHide"));

var StepHide$1 = as.as("button")(StepHide);

Step$1.Container = __chunk_8.StepContainer;
Step$1.Toggle = StepToggle$1;
Step$1.Show = StepShow$1;
Step$1.Hide = StepHide$1;
Step$1.Next = __chunk_8.StepNext;
Step$1.Previous = __chunk_8.StepPrevious;

exports.default = Step$1;
