'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var styled = require('styled-components');
var styled__default = _interopDefault(styled);
var styledTools = require('styled-tools');
var as = require('./as-abd2c25b.js');
var Base = require('./Base.js');
var React = _interopDefault(require('react'));
var PropTypes = _interopDefault(require('prop-types'));
var __chunk_8 = require('./chunk-30c3ebc0.js');
var __chunk_3 = require('./chunk-c7f60f29.js');
var Step = require('./Step.js');
var hoistNonReactStatics = _interopDefault(require('hoist-non-react-statics'));
var Hidden = require('./Hidden.js');
require('lodash/uniq');
require('react-known-props');
require('lodash/omit');
require('./chunk-7e606c56.js');
require('lodash/kebabCase');
require('./chunk-c628ddbd.js');
require('constate');
require('./chunk-e0ed6a07.js');
require('./chunk-df525803.js');

var Tabs = styled__default(Base.default).withConfig({
  displayName: "Tabs"
})(["display:flex;align-items:center;list-style:none;@media screen and (max-width:640px){overflow-x:auto;}", ";"], styledTools.prop("theme.Tabs"));

Tabs.defaultProps = {
  role: "tablist"
};

var Tabs$1 = as.as("ul")(Tabs);

var initialState = {
  loop: true,
  current: 0
};

// istanbul ignore next
var TabsContainer = function TabsContainer(props) {
  return React.createElement(__chunk_8.StepContainer, as._extends({}, props, {
    initialState: as._extends({}, initialState, props.initialState)
  }));
};

TabsContainer.propTypes = {
  initialState: PropTypes.object
};

/* eslint-disable no-param-reassign */
var createElementRef = function createElementRef(scope, property) {
  return function (element) {
    scope[property] = element;
    if (scope.props && scope.props.elementRef) {
      scope.props.elementRef(element);
    }
  };
};

var Component = function (_React$Component) {
  as.inherits(Component, _React$Component);

  function Component() {
    var _temp, _this, _ret;

    as.classCallCheck(this, Component);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = as.possibleConstructorReturn(this, _React$Component.call.apply(_React$Component, [this].concat(args))), _this), _this.show = function () {
      var _this$props = _this.props,
          show = _this$props.show,
          isCurrent = _this$props.isCurrent,
          tab = _this$props.tab;

      if (!isCurrent(tab)) {
        show(tab);
      }
    }, _this.keyDown = function (e) {
      var keyMap = {
        ArrowLeft: _this.props.previous,
        ArrowRight: _this.props.next
      };
      if (keyMap[e.key]) {
        e.preventDefault();
        keyMap[e.key]();
      }
    }, _temp), as.possibleConstructorReturn(_this, _ret);
  }

  Component.prototype.componentDidUpdate = function componentDidUpdate(prevProps) {
    var _props = this.props,
        current = _props.current,
        isCurrent = _props.isCurrent,
        tab = _props.tab;


    if (prevProps.current !== current && isCurrent(tab)) {
      this.element.focus();
    }
  };

  Component.prototype.render = function render() {
    var _props2 = this.props,
        isCurrent = _props2.isCurrent,
        tab = _props2.tab,
        className = _props2.className,
        onClick = _props2.onClick,
        onFocus = _props2.onFocus,
        onKeyDown = _props2.onKeyDown;


    var active = isCurrent(tab);
    var activeClassName = active ? "active" : "";
    var finalClassName = [className, activeClassName].filter(Boolean).join(" ");

    return React.createElement(Step.default, as._extends({
      id: tab + "Tab",
      step: tab,
      active: active,
      "aria-selected": active,
      "aria-controls": tab + "Panel",
      tabIndex: active ? 0 : -1,
      visible: true
    }, this.props, {
      onClick: __chunk_3.callAll(this.show, onClick),
      onFocus: __chunk_3.callAll(this.show, onFocus),
      onKeyDown: __chunk_3.callAll(this.keyDown, onKeyDown),
      className: finalClassName,
      elementRef: createElementRef(this, "element")
    }));
  };

  return Component;
}(React.Component);

var TabsTab = styled__default(Component).withConfig({
  displayName: "TabsTab"
})(["display:inline-flex;position:relative;flex:1;user-select:none;outline:none;align-items:center;white-space:nowrap;justify-content:center;text-decoration:none;height:2.5em;padding:0 0.5em;min-width:2.5em;&.active{font-weight:bold;}&[disabled]{pointer-events:none;}", ";"], styledTools.prop("theme.TabsTab"));

TabsTab.propTypes = {
  tab: PropTypes.string.isRequired,
  register: PropTypes.func.isRequired,
  update: PropTypes.func.isRequired,
  unregister: PropTypes.func.isRequired,
  isCurrent: PropTypes.func.isRequired,
  show: PropTypes.func.isRequired,
  next: PropTypes.func.isRequired,
  previous: PropTypes.func.isRequired,
  className: PropTypes.string,
  disabled: PropTypes.bool,
  onClick: PropTypes.func,
  onFocus: PropTypes.func,
  onKeyDown: PropTypes.func
};

var noop = function noop() {};

TabsTab.defaultProps = {
  role: "tab",
  register: noop,
  update: noop,
  unregister: noop,
  isCurrent: noop,
  show: noop,
  next: noop,
  previous: noop
};

var TabsTab$1 = as.as("li")(TabsTab);

var Component$1 = function Component(props) {
  var isCurrent = props.isCurrent,
      tab = props.tab;

  return React.createElement(Hidden.default, as._extends({
    id: tab + "Panel",
    "aria-labelledby": tab + "Tab",
    unmount: true,
    visible: isCurrent && isCurrent(tab)
  }, props));
};

hoistNonReactStatics(Component$1, Hidden.default);

var TabsPanel = styled__default(Component$1).withConfig({
  displayName: "TabsPanel"
})(["", ";"], styledTools.prop("theme.TabsPanel"));

TabsPanel.propTypes = {
  tab: PropTypes.string.isRequired,
  isCurrent: PropTypes.func.isRequired
};

TabsPanel.defaultProps = {
  role: "tabpanel"
};

var TabsPanel$1 = as.as("div")(TabsPanel);

var TabsNext = styled__default(__chunk_8.StepNext).withConfig({
  displayName: "TabsNext"
})(["", ";"], styledTools.prop("theme.TabsNext"));

var TabsNext$1 = as.as("button")(TabsNext);

var TabsPrevious = styled__default(__chunk_8.StepPrevious).withConfig({
  displayName: "TabsPrevious"
})(["", ";"], styledTools.prop("theme.TabsPrevious"));

var TabsPrevious$1 = as.as("button")(TabsPrevious);

Tabs$1.Container = TabsContainer;
Tabs$1.Tab = TabsTab$1;
Tabs$1.Panel = TabsPanel$1;
Tabs$1.Next = TabsNext$1;
Tabs$1.Previous = TabsPrevious$1;

exports.default = Tabs$1;
