'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = _interopDefault(require('react'));
var ReactDOM = require('react-dom');
var ReactDOM__default = _interopDefault(ReactDOM);
var styled = require('styled-components');
var styled__default = _interopDefault(styled);
var styledTools = require('styled-tools');
var as = require('./as-abd2c25b.js');
var Popover = require('./Popover.js');
var __chunk_7 = require('./chunk-a74c92bb.js');
require('lodash/uniq');
require('react-known-props');
require('lodash/omit');
require('prop-types');
require('popper.js');
require('./Hidden.js');
require('./chunk-c628ddbd.js');
require('hoist-non-react-statics');
require('./chunk-c7f60f29.js');
require('./Base.js');
require('./chunk-7e606c56.js');
require('lodash/kebabCase');
require('./chunk-df525803.js');
require('constate');
require('./chunk-e0ed6a07.js');
require('./Box.js');
require('lodash/uniqueId');
require('./Arrow.js');

/* eslint-disable react/no-find-dom-node, react/no-unused-state */

var Component = function (_React$Component) {
  as.inherits(Component, _React$Component);

  function Component() {
    var _temp, _this, _ret;

    as.classCallCheck(this, Component);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = as.possibleConstructorReturn(this, _React$Component.call.apply(_React$Component, [this].concat(args))), _this), _this.state = {
      visible: false
    }, _this.isControlled = function () {
      return typeof _this.props.visible !== "undefined";
    }, _this.show = function () {
      return _this.setState({ visible: true });
    }, _this.hide = function () {
      return _this.setState({ visible: false });
    }, _this.getTooltip = function () {
      return ReactDOM.findDOMNode(_this);
    }, _temp), as.possibleConstructorReturn(_this, _ret);
  }

  Component.prototype.componentDidMount = function componentDidMount() {
    var _getTooltip = this.getTooltip(),
        parentNode = _getTooltip.parentNode;

    if (parentNode && !this.isControlled()) {
      parentNode.addEventListener("mouseenter", this.show);
      parentNode.addEventListener("focus", this.show);
      parentNode.addEventListener("mouseleave", this.hide);
      parentNode.addEventListener("blur", this.hide);
    }
  };

  Component.prototype.componentWillUnmount = function componentWillUnmount() {
    var _getTooltip2 = this.getTooltip(),
        parentNode = _getTooltip2.parentNode;

    if (parentNode) {
      parentNode.removeEventListener("mouseenter", this.show);
      parentNode.removeEventListener("focus", this.show);
      parentNode.removeEventListener("mouseleave", this.hide);
      parentNode.removeEventListener("blur", this.hide);
    }
  };

  Component.prototype.render = function render() {
    var _ref = this.isControlled() ? this.props : this.state,
        visible = _ref.visible;

    return React.createElement(Popover.default, as._extends({}, this.props, { visible: visible }));
  };

  return Component;
}(React.Component);

var Tooltip = styled__default(Component).withConfig({
  displayName: "Tooltip"
})(["pointer-events:none;white-space:nowrap;text-transform:none;font-size:0.875em;text-align:center;color:white;background-color:#222;border-radius:0.15384em;padding:0.75em 1em;", ";"], styledTools.prop("theme.Tooltip"));

Tooltip.defaultProps = {
  role: "tooltip",
  placement: "top"
};

var Tooltip$1 = as.as("div")(Tooltip);

var TooltipArrow = styled__default(__chunk_7.PopoverArrow).withConfig({
  displayName: "TooltipArrow"
})(["color:#222;border:none;", ";"], styledTools.prop("theme.TooltipArrow"));

var TooltipArrow$1 = as.as("div")(TooltipArrow);

Tooltip$1.Arrow = TooltipArrow$1;

exports.default = Tooltip$1;
