'use strict';

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var kebabCase = _interopDefault(require('lodash/kebabCase'));
var __chunk_1 = require('./chunk-c628ddbd.js');

var bool = function bool(cssProp, validComponentProps) {
  return function (props) {
    var keys = Object.keys(props).filter(function (k) {
      return validComponentProps.indexOf(k) >= 0;
    }).filter(function (k) {
      return !!props[k];
    }).map(kebabCase);
    if (keys.length) {
      return cssProp + ": " + keys.join(" ") + ";";
    }
    return "";
  };
};

var value = function value(cssProp, componentProp) {
  return function (props) {
    var v = props[componentProp];
    if (typeof v === "undefined") return "";
    return cssProp + ": " + __chunk_1.numberToPx(v) + ";";
  };
};

exports.bool = bool;
exports.value = value;
