'use strict';

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = _interopDefault(require('react'));
var PropTypes = _interopDefault(require('prop-types'));
var constate = require('constate');
var as = require('./as-abd2c25b.js');

var initialState = { visible: false };

var toggle = function toggle() {
  return function (state) {
    return { visible: !state.visible };
  };
};

var show = function show() {
  return function () {
    return { visible: true };
  };
};

var hide = function hide() {
  return function () {
    return { visible: false };
  };
};

var HiddenContainer = function HiddenContainer(props) {
  return React.createElement(constate.Container, as._extends({}, props, {
    initialState: as._extends({}, initialState, props.initialState),
    actions: as._extends({ toggle: toggle, show: show, hide: hide }, props.actions)
  }));
};

HiddenContainer.propTypes = {
  initialState: PropTypes.object,
  actions: PropTypes.objectOf(PropTypes.func)
};

exports.HiddenContainer = HiddenContainer;
