'use strict';

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = _interopDefault(require('react'));
var PropTypes = _interopDefault(require('prop-types'));
var styled = require('styled-components');
var styled__default = _interopDefault(styled);
var styledTools = require('styled-tools');
var as = require('./as-abd2c25b.js');
var __chunk_3 = require('./chunk-c7f60f29.js');
var Base = require('./Base.js');

var Component = function Component(_ref) {
  var onClick = _ref.onClick,
      props = as.objectWithoutProperties(_ref, ["onClick"]);
  return React.createElement(Base.default, as._extends({ onClick: __chunk_3.callAll(props.hide, onClick) }, props));
};

var HiddenHide = styled__default(Component).withConfig({
  displayName: "HiddenHide"
})(["", ";"], styledTools.prop("theme.HiddenHide"));

HiddenHide.propTypes = {
  hide: PropTypes.func.isRequired,
  onClick: PropTypes.func
};

var HiddenHide$1 = as.as("button")(HiddenHide);

var Component$1 = function Component(_ref) {
  var onClick = _ref.onClick,
      props = as.objectWithoutProperties(_ref, ["onClick"]);
  return React.createElement(Base.default, as._extends({ onClick: __chunk_3.callAll(props.show, onClick) }, props));
};

var HiddenShow = styled__default(Component$1).withConfig({
  displayName: "HiddenShow"
})(["", ";"], styledTools.prop("theme.HiddenShow"));

HiddenShow.propTypes = {
  show: PropTypes.func.isRequired,
  onClick: PropTypes.func
};

var HiddenShow$1 = as.as("button")(HiddenShow);

var Component$2 = function Component(_ref) {
  var onClick = _ref.onClick,
      props = as.objectWithoutProperties(_ref, ["onClick"]);
  return React.createElement(Base.default, as._extends({ onClick: __chunk_3.callAll(props.toggle, onClick) }, props));
};

var HiddenToggle = styled__default(Component$2).withConfig({
  displayName: "HiddenToggle"
})(["", ";"], styledTools.prop("theme.HiddenToggle"));

HiddenToggle.propTypes = {
  toggle: PropTypes.func.isRequired,
  onClick: PropTypes.func
};

var HiddenToggle$1 = as.as("button")(HiddenToggle);

exports.HiddenHide = HiddenHide$1;
exports.HiddenShow = HiddenShow$1;
exports.HiddenToggle = HiddenToggle$1;
